Subject: [PATCH RESEND] arm: don't break misaligned NEON load/store

From: [email-masked] (Robin Murphy)
Date: Thu, 25 Sep 2014 12:05:28 +0100

On 22/09/14 14:48, Robin Murphy wrote:
> The alignment fixup incorrectly decodes faulting ARM VLDn/VSTn
> instructions (where the optional alignment hint is given but incorrect)
> as LDR/STR, leading to register corruption. Detect these and correctly
> treat them as unhandled, so that userspace gets the fault it expects.
>
> Reported-by: Simon Hosie <[email-masked]>
> Signed-off-by: Robin Murphy <[email-masked]>
> Cc: <[email-masked]>
> ---
>
> Hi all,
>
> This was met with a resounding silence a while back[1], but the bug is
> still causing annoyance - apparently Clang intrinsics can be a little
> over-eager with alignment hints. Regardless of whose fault that is,
> the kernel shouldn't be silently mangling registers unexpectedly.
>
> Any objections to me dropping this into the patch system?
>

Since nobody's voiced any complaints, I've submitted this as 8165/1.

Robin.